<?php

/*
   
   File : lib/imp.lib.php3
   $Author: paudley $
   $Revision: 1.3 $
   $Date: 1998/09/30 19:06:15 $
   
   IMP : Copyright 1998 Patrick Audley paudley@blackcat.ca
   
   This code is under the GNU Public License
   See the file COPYING in this directory

*/

/* SSL certificate processing. */
class SSLstate {
  var $valid_cert_found;
  var $valid_auth_found;
  var $verified;
  var $ssl_user;
  var $ssl_pass;
  var $client_dn;
  var $ssl_server;
  var $ssl_port;
  var $ssl_folder;

  Function SSLstate() {
    $this->valid_cert_found = false;
    $this->valid_auth_found = false;
    $this->verfied = false;
    $this->ssl_user = "";
    $this->ssl_pass = "";
    $this->ssl_server = "";
    $this->ssl_port = 143;
    $this->ssl_folder = "";
    $this->client_dn = "";
  }

  function snoop_dn() {
    global $default;
    if( $default->ssl->snoop_dn ) {
      echo "<pre><b>Client DN:</b> \"".$GLOBALS["SSL_CLIENT_DN"]."\"<br><b>Issuer DN:</b> \"".$GLOBALS["SSL_ISSUER_DN"]."\"<br>\n</pre>";
    }
  }

  function verify_cert() {
    global $SSL_CLIENT_DN, $SSL_ISSUER_DN, $default;
    if( $this->verified ) { return $this->valid_auth_found; }

    $this->verfied = true;
    $this->client_dn = $SSL_CLIENT_DN;

    if( $default->ssl->client_auth_required ) {
      if( empty($SSL_CLIENT_DN) || empty($SSL_ISSUER_DN) ) {
        status("Invalid Cert.");
        $this->valid_cert_found = false;
        return false;
      }
      if( $default->ssl->issuers[$SSL_ISSUER_DN] != true ) {
        status("Invalid Issuer");
        $this->valid_cert_found = false;
        return false;
      }
    }
    $this->valid_cert_found = true;

  /*   FIXME!!  The database routines need to be
   *   moved to mysql.lib.php3 and made generic.
   */

    if( !($db = mysql_pconnect("localhost","www-data")) ) {
      status("Error in SSL->IMAP __FILE__(__LINE__): DB not found."); 
      return false;
    }
    if( !($dbs = mysql_select_db("imp",$db)) ) {
      status("Error in SSL->IMAP __FILE__(__LINE__): Can't select DB."); 
      return false;
    }
    $res = mysql_db_query("imp","select * from ssl_to_imp where DN = '".$GLOBALS["SSL_CLIENT_DN"]."'",$db);
    if( mysql_num_rows($res) > 0 ) {
      $arr = mysql_fetch_array($res);
      $this->ssl_user = $arr["username"];
      $this->ssl_pass = $arr["password"];
      $s = split(":",$arr["server"]);
      $this->ssl_server = $s[0];
      if( isset($s[1]) )
	$this->ssl_port = $s[1];
      else
	$this->ssl_port = 143;
      $this->ssl_folder = $arr["folder"];
      $this->valid_auth_found = true;
    } else {
      status("No auth found in database");
      $this->valid_auth_found = false;
    }
    mysql_free_result($res);  
    return $this->valid_auth_found;
  }

  function process() {
    global $default;
    if( $default->ssl->client_auth_required || $default->ssl->issuers || $default->ssl->check_cert ) { 
      $this->verify_cert();
      return true; 
    }
    return false;
  }

  function login() {
    global $reason, $default;
    if( $this->process() ) {
      $this->snoop_dn(); 
      $this->verify_cert();
      
      if( $this->valid_cert_found ) {
	
	$CNr = split("/",$this->client_dn);
	$CN = "";
	$Email = array();
	for($i=0; $i<@count($CNr); $i++) {
	  $CNw = split("=",$CNr[$i]);
	  if( $CNw[0] == "CN" ) {
	    $CN = $CNw[1];
	  }
	  if( $CNw[0] == "Email" ) {
	    $Email[0] = $CNw[1];
	    $EMr = split("@",$CNw[1]);
	    $Email[1] = $EMr[0];
	    $Email[2] = $EMr[1];
	  }
	}
	status( 'Welcome to Imp, '.$CN);
      } else {
	
	if( $default->ssl->client_auth_required )
	  $reason = 'nocert';
      }
      
      if( !$this->valid_auth_found ) {
	if( $default->cyrus->auto_create && $default->cyrus->enabled ) {
	  include( './lib/cyrus_auto_create.php3' );
	} else {
	  $reason = 'noaccount';
	}
      }
       
      include( "$default->include_dir/login.php3-ssl_login.inc" );
    }
  }
}

$ssl = new SSLstate;

?>
